#include <iterator>
#include <fstream>
#include <string>
#include <map>
using namespace std;

#ifdef WIN32
#define CRLF 2
#else
#define CRLF 1
#endif


int main(int argc, char* argv[])
{
	// load the lemmas MAP 
	map<string, string> maplemma;

	ifstream ifi("lm.dat");
    if (ifi.is_open())
	{
        string line;

        while (!ifi.eof())
        {
            getline(ifi, line);
			int idx = line.find_first_of(' ');
			maplemma[line.substr(0, idx)] = line.substr(idx + 1, line.size() - CRLF - idx + 1);
        }

        ifi.close();
    }

	// create the output file with lemmatized content
	fstream fp("in.txt");
	if (fp.is_open())
	{
	    ofstream of_file("out.txt",  ios_base::out);

		string word = "";
		map<string, string>::iterator it;
		typedef std::istreambuf_iterator<char> buf_iter;


		for(buf_iter i(fp), e; i != e; ++i)
		{
			char c = tolower(*i); 
			
			if (c > 96 && c < 123) // lemmatize words that only contains a-z characters
			{
				word += c;
				continue;
			}
			else
			{
				if (word.size() > 1)
				{
					it = maplemma.find(word);
					if (it != maplemma.end())
						word = it->second;
				}

				of_file << word;
				word = "";
			}

			of_file << c;
		}

		fp.close();

		of_file << word;
		of_file.close();
	}

	return 0;
}

